export const matcher = (text, query, options = {}) => parse(text, query
    .replace(/\?|\*|\(|\||\[|\^|\.|\+|\)|\]|\$/g, "")
    .split(options.delimiter ? options.delimiter : " "), options);
const parse = (text, queryList, options = {}) => {
    if (text === "") {
        return [];
    }
    const query = queryList.shift();
    if (query === undefined || query === "") {
        return [{ item: text, highlight: false }];
    }
    const regExpFlag = ["g"];
    if (!options.caseSensitive) {
        regExpFlag.push("i");
    }
    const regExp = new RegExp(query, regExpFlag.join(""));
    const matches = Array.from(text.matchAll(regExp), (match) => match[0]);
    return text
        .split(regExp)
        .map((item, index, itemArray) => {
        const result = parse(item, [...queryList], options);
        if (index === itemArray.length - 1) {
            return result;
        }
        result.push({ item: matches[index], highlight: true });
        return result;
    })
        .reduce((accumulate, current) => {
        accumulate.push(...current);
        return accumulate;
    }, []);
};
